/*  einsc -- a compiler for eins
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: DefaultVisitor.java,v 1.2 2005/04/27 13:56:08 dragos Exp $
 */

package einsc;

import einsc.Tree.*;


/**  Implements a visitor that resorts to a default case
 *   if the particular visitor method was not overridden.
 */
abstract public class DefaultVisitor implements Visitor {
    public void caseBad(Bad tree)             { caseDefault(tree); }

    public void caseProgram(Program tree)     { caseDefault(tree); }
    public void caseClassDef(ClassDef tree)   { caseDefault(tree); }
    public void caseFunDef(FunDef tree)       { caseDefault(tree); }
    public void caseFormal(Formal tree)       { caseDefault(tree); }

    public void caseIntType(IntType tree)     { caseDefault(tree); }
    public void caseTypeIdent(TypeIdent tree) { caseDefault(tree); }
    public void caseFunType(FunType tree)     { caseDefault(tree); }
    public void caseArrayType(ArrayType tree) { caseDefault(tree); }

    public void caseWhile(While tree)         { caseDefault(tree); }
    public void caseVarDef(VarDef tree)       { caseDefault(tree); }
    public void caseAssign(Assign tree)       { caseDefault(tree); }
    public void caseDo(Do tree)               { caseDefault(tree); }

    public void caseIf(If tree)               { caseDefault(tree); }
    public void caseUnop(Unop tree)           { caseDefault(tree); }
    public void caseBinop(Binop tree)         { caseDefault(tree); }
    public void caseIdent(Ident tree)         { caseDefault(tree); }
    public void caseNullLit(NullLit tree)     { caseDefault(tree); }
    public void caseIntLit(IntLit tree)       { caseDefault(tree); }
    public void caseApply(Apply tree)         { caseDefault(tree); }
    public void caseBlock(Block tree)         { caseDefault(tree); }
    public void caseNew(New tree)             { caseDefault(tree); }
    public void caseNewArray(NewArray tree)   { caseDefault(tree); }
    public void caseSelect(Select tree)       { caseDefault(tree); }
    public void caseIndex(Index tree)         { caseDefault(tree); }

    public abstract void caseDefault(Tree tree);
}
