/*  einsc -- a compiler for eins
 *    Lexical token classes
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: Tokens.java,v 1.2 2005/04/27 13:56:08 dragos Exp $
 */
package einsc;


/** This class defines all token classes of eins.
 */
interface Tokens {

    int EOF           = -1; // end of file
    int BAD           =  0; // unknown token

    int IDENT         =  1; // identifier
    int NUMBER        =  2; // number
    int STRING        =  3; // string

    int LPAREN        =  4; // "("
    int RPAREN        =  5; // ")"
    int LBRACE        =  6; // "{"
    int RBRACE        =  7; // "}"
    int COMMA         =  8; // ","
    int SEMICOLON     =  9; // ";"
    int COLON         = 10; // ":"
    int EQUAL         = 11; // "="
    int EQ            = 12; // "=="
    int NOT           = 13; // "!"
    int NE            = 14; // "!="
    int LT            = 15; // "<"
    int LE            = 16; // "<="
    int GT            = 17; // ">"
    int GE            = 18; // ">="
    int ARROW         = 19; // "=>"
    int ADD           = 20; // "+"
    int SUB           = 21; // "-"
    int MUL           = 22; // "*"
    int DIV           = 23; // "/"
    int MOD           = 24; // "%"
    int AND           = 25; // "&"
    int OR            = 26; // "|"
    int DOT           = 27; // "."

    int INT           = 28; // "Int"

    int DEF           = 29; // "def"
    int CLASS         = 30; // "class"
    int VAL           = 31; // "val"

    int WHILE         = 32; // "while"
    int VAR           = 33; // "var"
    int LET           = 34; // "let"
    int DO            = 35; // "do"

    int IF            = 36; // "if"
    int ELSE          = 37; // "else"
    int NEW           = 38; // "new"
    int NULL          = 39; // "null"
    int TRUE          = 40; // "true"
    int FALSE         = 41; // "false"
    
    int LBRACKET      = 50; // "["
    int RBRACKET      = 51; // "]"
}
