/*  einsc -- a compiler for eins
 *    Representation of the abstract syntax
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: Visitor.java,v 1.2 2005/04/27 13:56:08 dragos Exp $
 */

package einsc;

import einsc.Tree.*;


/** The visitor interface.
 */
public interface Visitor {
    void caseBad(Bad tree);

    void caseProgram(Program tree);
    void caseClassDef(ClassDef tree);
    void caseFunDef(FunDef tree);
    void caseFormal(Formal tree);

    void caseIntType(IntType tree);
    void caseTypeIdent(TypeIdent tree);
    void caseFunType(FunType tree);
    void caseArrayType(ArrayType tree);

    void caseWhile(While tree);
    void caseVarDef(VarDef tree);
    void caseAssign(Assign tree);
    void caseDo(Do tree);

    void caseIf(If tree);
    void caseUnop(Unop tree);
    void caseBinop(Binop tree);
    void caseIdent(Ident tree);
    void caseNullLit(NullLit tree);
    void caseIntLit(IntLit tree);
    void caseApply(Apply tree);
    void caseBlock(Block tree);
    void caseNew(New tree);
    void caseNewArray(NewArray tree);
    void caseSelect(Select tree);
    void caseIndex(Index tree);
}
